searchNodes=[{"doc":"Tesla middleware for case conversion of request and response body keys. This middleware will do the case conversion of body keys using the functions defined in the options before sending the request and after receiving the response. Examples defmodule MyClient do use Tesla plug TeslaKeys.Middleware.Case # use defaults # or plug TeslaKeys.Middleware.Case , encoder : &amp; Recase . to_camel / 1 , serializer : &amp; Recase.Enumerable . atomize_keys / 2 # or plug TeslaKeys.Middleware.Case , encoder : &amp; String . upcase / 1 , serializer : &amp; serializer / 2 defp serializer ( data , fun ) when is_map ( data ) , do : Map . new ( data , fn { key , value } -&gt; { then ( key , fun ) , value } end ) defp serializer ( data , fun ) when is_list ( data ) , do : Enum . map ( data , &amp; serializer ( &amp;1 , fun ) ) defp serializer ( data , _fun ) , do : data end Options :serializer - serializer function with arity 2, receives the body data as the first parameter and the :encoder or :decoder option as the second parameter, (defaults to &amp;Recase.Enumerable.stringify_keys/2 ) :encoder - encoding function, e.g &amp;Recase.to_camel/1 , &amp;Recase.to_pascal/1 (defaults to &amp;Recase.to_camel/1 ) :decoder - decoding function (defaults to &amp;Recase.to_snake/1 )","ref":"TeslaKeys.Middleware.Case.html","title":"TeslaKeys.Middleware.Case","type":"module"},{"doc":"Tesla middleware for remapping request and response body keys. This middleware will remap the body keys by their respective relations defined in the options before sending the request and after receiving the response. All unmapped keys will be kept as is when doing the convertion. Examples defmodule MyClient do use Tesla plug TeslaKeys.Middleware.Remapper , keys : %{ # key expected by API =&gt; key you want to handle instead &quot;pong&quot; =&gt; &quot;ping&quot; , &quot;bar&quot; =&gt; &quot;foo&quot; , &quot;bye&quot; =&gt; &quot;hey&quot; } # or if you are working with atom keys map plug TeslaKeys.Middleware.Remapper , keys : [ # &quot;key expected by API&quot;: :&quot;key you want to handle instead&quot; pong : :ping , bar : :foo , bye : :hey ] end Options :keys - relation of keys expected by the API and that you want to handle","ref":"TeslaKeys.Middleware.Remapper.html","title":"TeslaKeys.Middleware.Remapper","type":"module"},{"doc":"Aggregate of useful middlewares to manipulate body keys","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding tesla_keys to your list of dependencies in mix.exs : def deps do [ { :tesla_keys , &quot;~&gt; 0.2&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"You can find usage examples in the Guides section.","ref":"readme.html#examples","title":"Overview - Examples","type":"extras"},{"doc":"","ref":"usage.html","title":"Usage","type":"extras"},{"doc":"First of all, we need to install tesla_keys and all dependencies to work with tesla : Mix . install ( ~w[tesla jason tesla_keys]a )","ref":"usage.html#setup","title":"Usage - Setup","type":"extras"},{"doc":"Let's create an HTTP client to consume the {JSON} Placeholder fake API. To learn more about it, see the guide . defmodule Client do use Tesla plug Tesla.Middleware.BaseUrl , &quot;https://jsonplaceholder.typicode.com/&quot; # middleware for remapping request and response body keys plug TeslaKeys.Middleware.Remapper , keys : [ { &quot;body&quot; , &quot;content&quot; } ] # middleware for case conversion of the request and response body keys plug TeslaKeys.Middleware.Case plug Tesla.Middleware.Logger plug Tesla.Middleware.PathParams plug Tesla.Middleware.JSON def list_posts ( ) do get ( &quot;/posts&quot; ) end def update_post ( id , body ) do params = [ id : id ] put ( &quot;/posts/:id&quot; , body , opts : [ path_params : params ] ) end end In the example above, the {JSON} Placeholder expects the post body to have the following JSON structure: { &quot;id&quot;: 1, &quot;title&quot;: &quot;...&quot;, &quot;body&quot;: &quot;...&quot;, &quot;userId&quot;: 1 } But when we use the TeslaKeys plugs to handle our request and response, we make some changes to the body data along the way, getting the following structure relative to the previous one: %{ &quot;id&quot; =&gt; 1 , &quot;title&quot; =&gt; &quot;...&quot; , &quot;content&quot; =&gt; &quot;...&quot; , &quot;user_id&quot; =&gt; 1 } That way, when we use TeslaKeys.Middleware.Remapper we are remapping the body key to content and when we use TeslaKeys.Middleware.Case , we are doing the case conversion. params = %{ &quot;title&quot; =&gt; &quot;TeslaKeys&quot; , &quot;content&quot; =&gt; &quot;Manipulates body keys&quot; , &quot;user_id&quot; =&gt; 1 } with { :ok , %{ body : body } } &lt;- Client . update_post ( 1 , params ) do body end When running the above request, we noticed that to satisfy the structure expected by the API, the request was converted when sent like: # requested as: %{ &quot;title&quot; =&gt; &quot;TeslaKeys&quot; , &quot;content&quot; =&gt; &quot;Manipulates body keys&quot; , &quot;user_id&quot; =&gt; 1 } # converted to: %{ &quot;title&quot; =&gt; &quot;TeslaKeys&quot; , &quot;body&quot; =&gt; &quot;Manipulates body keys&quot; , &quot;userId&quot; =&gt; 1 } but when responded, it was converted again to get the desired result: # responded as: %{ &quot;id&quot; =&gt; 1 , &quot;title&quot; =&gt; &quot;TeslaKeys&quot; , &quot;body&quot; =&gt; &quot;Manipulates body keys&quot; , &quot;userId&quot; =&gt; 1 } # converted to: %{ &quot;id&quot; =&gt; 1 , &quot;title&quot; =&gt; &quot;TeslaKeys&quot; , &quot;content&quot; =&gt; &quot;Manipulates body keys&quot; , &quot;user_id&quot; =&gt; 1 }","ref":"usage.html#using","title":"Usage - Using","type":"extras"}]